NopAnnotationIntrospector (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map.introspect

## Class NopAnnotationIntrospector

- java.lang.Object
- - org.codehaus.jackson.map.AnnotationIntrospector
  - - org.codehaus.jackson.map.introspect.NopAnnotationIntrospector

-     public class NopAnnotationIntrospector
      extends AnnotationIntrospector

  Dummy, "no-operation" implementation of `AnnotationIntrospector`. Can be used as is to suppress handling of annotations; or as a basis for simple complementary annotators

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.AnnotationIntrospector

      `AnnotationIntrospector.Pair, AnnotationIntrospector.ReferenceProperty`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static NopAnnotationIntrospector` | `instance` Static immutable and shareable instance that can be used as "null" introspector: one that never finds any annotation information.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `NopAnnotationIntrospector()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Class<JsonDeserializer<?>>` | `findContentDeserializer(Annotated am)` Method for getting a deserializer definition for content (values) of associated `Collection`, `array` or `Map` property.
    `String` | `findDeserializablePropertyName(AnnotatedField af)` Method for checking whether given member field represent a deserializable logical property; and if so, returns the name of that property.
    `Class<?>` | `findDeserializationContentType(Annotated am, JavaType t, String propName)` Method for accessing additional narrowing type definition that a method can have, to define more specific content type to use; content refers to Map values and Collection/array elements.
    `Class<?>` | `findDeserializationKeyType(Annotated am, JavaType t, String propName)` Method for accessing additional narrowing type definition that a method can have, to define more specific key type to use.
    `Class<?>` | `findDeserializationType(Annotated am, JavaType t, String propName)` Method for accessing annotated type definition that a method can have, to be used as the type for serialization instead of the runtime type.
    `Object` | `findDeserializer(Annotated am)` Method for getting a deserializer definition on specified method or field.
    `String` | `findEnumValue(Enum<?> value)` Method for determining the String value to use for serializing given enumeration entry; used when serializing enumerations as Strings (the standard method).
    `String` | `findGettablePropertyName(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests property name associated with method that may be a "getter".
    `Boolean` | `findIgnoreUnknownProperties(AnnotatedClass ac)` Method for checking whether an annotation indicates that all unknown properties
    `Class<KeyDeserializer>` | `findKeyDeserializer(Annotated am)` Method for getting a deserializer definition for keys of associated `Map` property.
    `String[]` | `findPropertiesToIgnore(AnnotatedClass ac)` Method for finding list of properties to ignore for given class (null is returned if not specified).
    `String` | `findPropertyNameForParam(AnnotatedParameter param)` Method for checking whether given set of annotations indicates property name for associated parameter.
    `String` | `findRootName(AnnotatedClass ac)` Method for locating name used as "root name" (for use by some serializers when outputting root-level object -- mostly for XML compatibility purposes) for given class, if one is defined.
    `String` | `findSerializablePropertyName(AnnotatedField af)` Method for checking whether given member field represent a serializable logical property; and if so, returns the name of that property.
    `String[]` | `findSerializationPropertyOrder(AnnotatedClass ac)` Method for accessing defined property serialization order (which may be partial).
    `Boolean` | `findSerializationSortAlphabetically(AnnotatedClass ac)` Method for checking whether an annotation indicates that serialized properties for which no explicit is defined should be alphabetically (lexicograpically) ordered
    `Class<?>` | `findSerializationType(Annotated a)` Method for accessing annotated type definition that a method/field can have, to be used as the type for serialization instead of the runtime type.
    `JsonSerialize.Typing` | `findSerializationTyping(Annotated a)` Method for accessing declared typing mode annotated (if any).
    `Class<?>[]` | `findSerializationViews(Annotated a)` Method for checking if annotated serializable property (represented by field or getter method) has definitions for views it is to be included in.
    `Object` | `findSerializer(Annotated am)` Method for getting a serializer definition on specified method or field.
    `String` | `findSettablePropertyName(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests property name associated with method that may be a "setter".
    `boolean` | `hasAsValueAnnotation(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests that the return value of annotated method should be used as "the value" of the object instance; usually serialized as a primitive value such as String or number.
    `boolean` | `hasIgnoreMarker(AnnotatedMember member)` Method called to check whether given property is marked to be ignored; but NOT to determine if it should necessarily be ignored, since that may depend on other factors.
    `boolean` | `isHandled(Annotation ann)` Method called by framework to determine whether given annotation is handled by this introspector.
    `boolean` | `isIgnorableConstructor(AnnotatedConstructor c)`
    `boolean` | `isIgnorableField(AnnotatedField f)` Method for checking whether there is an annotation that indicates that given field should be ignored for all operations (serialization, deserialization).
    `boolean` | `isIgnorableMethod(AnnotatedMethod m)` Method for checking whether there is an annotation that indicates that given method should be ignored for all operations (serialization, deserialization).

    - ### Methods inherited from class org.codehaus.jackson.map.AnnotationIntrospector

      `allIntrospectors, allIntrospectors, findAutoDetectVisibility, findCachability, findContentSerializer, findFilterId, findInjectableValueId, findKeySerializer, findPropertyContentTypeResolver, findPropertyTypeResolver, findReferenceType, findSerializationContentType, findSerializationInclusion, findSerializationKeyType, findSubtypes, findTypeName, findTypeResolver, findValueInstantiator, hasAnyGetterAnnotation, hasAnySetterAnnotation, hasCreatorAnnotation, isIgnorableType, nopInstance, pair, shouldUnwrapProperty`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### instance

          public static final NopAnnotationIntrospector instance

      Static immutable and shareable instance that can be used as "null" introspector: one that never finds any annotation information.

  - ### Constructor Detail

    - #### NopAnnotationIntrospector

          public NopAnnotationIntrospector()

  - ### Method Detail

    - #### isHandled

          public boolean isHandled(Annotation ann)

      Description copied from class: `AnnotationIntrospector`
      Method called by framework to determine whether given annotation is handled by this introspector.
      Specified by:
        `isHandled` in class `AnnotationIntrospector`

    - #### findEnumValue

          public String findEnumValue(Enum<?> value)

      Description copied from class: `AnnotationIntrospector`
      Method for determining the String value to use for serializing given enumeration entry; used when serializing enumerations as Strings (the standard method).

      NOTE: implemented since 1.9.11, to make things work even when annotation introspection is disabled.

      Overrides:
        `findEnumValue` in class `AnnotationIntrospector`
      Returns:
        Serialized enum value.

    - #### findRootName

          public String findRootName(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for locating name used as "root name" (for use by some serializers when outputting root-level object -- mostly for XML compatibility purposes) for given class, if one is defined. Returns null if no declaration found; can return explicit empty String, which is usually ignored as well as null.
      Specified by:
        `findRootName` in class `AnnotationIntrospector`

    - #### findPropertiesToIgnore

          public String[] findPropertiesToIgnore(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for finding list of properties to ignore for given class (null is returned if not specified). List of property names is applied after other detection mechanisms, to filter out these specific properties from being serialized and deserialized.
      Specified by:
        `findPropertiesToIgnore` in class `AnnotationIntrospector`

    - #### findIgnoreUnknownProperties

          public Boolean findIgnoreUnknownProperties(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether an annotation indicates that all unknown properties
      Specified by:
        `findIgnoreUnknownProperties` in class `AnnotationIntrospector`

    - #### hasIgnoreMarker

          public boolean hasIgnoreMarker(AnnotatedMember member)

      Description copied from class: `AnnotationIntrospector`
      Method called to check whether given property is marked to be ignored; but NOT to determine if it should necessarily be ignored, since that may depend on other factors.

      Default implementation calls existing 'isIgnored' methods such as `AnnotationIntrospector.isIgnorableField(AnnotatedField)` and `AnnotationIntrospector.isIgnorableMethod(AnnotatedMethod)`.

      Overrides:
        `hasIgnoreMarker` in class `AnnotationIntrospector`

    - #### isIgnorableConstructor

          public boolean isIgnorableConstructor(AnnotatedConstructor c)

      Specified by:
        `isIgnorableConstructor` in class `AnnotationIntrospector`

    - #### isIgnorableMethod

          public boolean isIgnorableMethod(AnnotatedMethod m)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether there is an annotation that indicates that given method should be ignored for all operations (serialization, deserialization).

      Note that this method should ONLY return true for such explicit ignoral cases; and not if method just happens not to be visible for annotation processor.

      Specified by:
        `isIgnorableMethod` in class `AnnotationIntrospector`
      Returns:
        True, if an annotation is found to indicate that the method should be ignored; false if not.

    - #### isIgnorableField

          public boolean isIgnorableField(AnnotatedField f)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether there is an annotation that indicates that given field should be ignored for all operations (serialization, deserialization).
      Specified by:
        `isIgnorableField` in class `AnnotationIntrospector`
      Returns:
        True, if an annotation is found to indicate that the field should be ignored; false if not.

    - #### findSerializer

          public Object findSerializer(Annotated am)

      Description copied from class: `AnnotationIntrospector`
      Method for getting a serializer definition on specified method or field. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.

      Note: this variant was briefly deprecated for 1.7; should not be

      Specified by:
        `findSerializer` in class `AnnotationIntrospector`

    - #### findSerializationType

          public Class<?> findSerializationType(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing annotated type definition that a method/field can have, to be used as the type for serialization instead of the runtime type. Type returned (if any) needs to be widening conversion (super-type). Declared return type of the method is also considered acceptable.
      Specified by:
        `findSerializationType` in class `AnnotationIntrospector`
      Returns:
        Class to use instead of runtime type

    - #### findSerializationTyping

          public JsonSerialize.Typing findSerializationTyping(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing declared typing mode annotated (if any). This is used for type detection, unless more granular settings (such as actual exact type; or serializer to use which means no type information is needed) take precedence.
      Specified by:
        `findSerializationTyping` in class `AnnotationIntrospector`
      Returns:
        Typing mode to use, if annotation is found; null otherwise

    - #### findSerializationViews

          public Class<?>[] findSerializationViews(Annotated a)

      Description copied from class: `AnnotationIntrospector`
      Method for checking if annotated serializable property (represented by field or getter method) has definitions for views it is to be included in. If null is returned, no view definitions exist and property is always included; otherwise it will only be included for views included in returned array. View matches are checked using class inheritance rules (sub-classes inherit inclusions of super-classes)
      Specified by:
        `findSerializationViews` in class `AnnotationIntrospector`
      Parameters:
        `a` - Annotated serializable property (field or getter method)
      Returns:
        Array of views (represented by classes) that the property is included in; if null, always included (same as returning array containing `Object.class`)

    - #### findSerializationPropertyOrder

          public String[] findSerializationPropertyOrder(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing defined property serialization order (which may be partial). May return null if no ordering is defined.
      Specified by:
        `findSerializationPropertyOrder` in class `AnnotationIntrospector`

    - #### findSerializationSortAlphabetically

          public Boolean findSerializationSortAlphabetically(AnnotatedClass ac)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether an annotation indicates that serialized properties for which no explicit is defined should be alphabetically (lexicograpically) ordered
      Specified by:
        `findSerializationSortAlphabetically` in class `AnnotationIntrospector`

    - #### findGettablePropertyName

          public String findGettablePropertyName(AnnotatedMethod am)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given method has an annotation that suggests property name associated with method that may be a "getter". Should return null if no annotation is found; otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use standard bean name detection if applicable; method name if not".
      Specified by:
        `findGettablePropertyName` in class `AnnotationIntrospector`

    - #### hasAsValueAnnotation

          public boolean hasAsValueAnnotation(AnnotatedMethod am)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given method has an annotation that suggests that the return value of annotated method should be used as "the value" of the object instance; usually serialized as a primitive value such as String or number.
      Specified by:
        `hasAsValueAnnotation` in class `AnnotationIntrospector`
      Returns:
        True if such annotation is found (and is not disabled); false if no enabled annotation is found

    - #### findDeserializablePropertyName

          public String findDeserializablePropertyName(AnnotatedField af)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given member field represent a deserializable logical property; and if so, returns the name of that property. Should return null if no annotation is found (indicating it is not a deserializable field); otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use the field name as is".
      Specified by:
        `findDeserializablePropertyName` in class `AnnotationIntrospector`

    - #### findDeserializationContentType

          public Class<?> findDeserializationContentType(Annotated am,
                                                JavaType t,
                                                String propName)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing additional narrowing type definition that a method can have, to define more specific content type to use; content refers to Map values and Collection/array elements. It should be only be used with Map, Collection and array types.
      Specified by:
        `findDeserializationContentType` in class `AnnotationIntrospector`
        `t` - Assumed content (value) type before considering annotations
        `propName` - Logical property name of the property that uses type, if known; null for types not associated with property
      Returns:
        Class specifying more specific type to use instead of declared type, if annotation found; null if not

    - #### findDeserializationKeyType

          public Class<?> findDeserializationKeyType(Annotated am,
                                            JavaType t,
                                            String propName)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing additional narrowing type definition that a method can have, to define more specific key type to use. It should be only be used with `Map` types.
      Specified by:
        `findDeserializationKeyType` in class `AnnotationIntrospector`
        `t` - Assumed key type before considering annotations
        `propName` - Logical property name of the property that uses type, if known; null for types not associated with property
      Returns:
        Class specifying more specific type to use instead of declared type, if annotation found; null if not

    - #### findDeserializationType

          public Class<?> findDeserializationType(Annotated am,
                                         JavaType t,
                                         String propName)

      Description copied from class: `AnnotationIntrospector`
      Method for accessing annotated type definition that a method can have, to be used as the type for serialization instead of the runtime type. Type must be a narrowing conversion (i.e.subtype of declared type). Declared return type of the method is also considered acceptable.
      Specified by:
        `findDeserializationType` in class `AnnotationIntrospector`
        `t` - Assumed type before considering annotations
        `propName` - Logical property name of the property that uses type, if known; null for types not associated with property
      Returns:
        Class to use for deserialization instead of declared type

    - #### findDeserializer

          public Object findDeserializer(Annotated am)

      Description copied from class: `AnnotationIntrospector`
      Method for getting a deserializer definition on specified method or field. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.

      Note: this variant was briefly deprecated for 1.7; but it turns out we really should not try to push BeanProperty through at this point

      Specified by:
        `findDeserializer` in class `AnnotationIntrospector`

    - #### findKeyDeserializer

          public Class<KeyDeserializer> findKeyDeserializer(Annotated am)

      Description copied from class: `AnnotationIntrospector`
      Method for getting a deserializer definition for keys of associated `Map` property. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.
      Specified by:
        `findKeyDeserializer` in class `AnnotationIntrospector`

    - #### findContentDeserializer

          public Class<JsonDeserializer<?>> findContentDeserializer(Annotated am)

      Description copied from class: `AnnotationIntrospector`
      Method for getting a deserializer definition for content (values) of associated `Collection`, `array` or `Map` property. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class`); if value of different type is returned, a runtime exception may be thrown by caller.
      Specified by:
        `findContentDeserializer` in class `AnnotationIntrospector`

    - #### findPropertyNameForParam

          public String findPropertyNameForParam(AnnotatedParameter param)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given set of annotations indicates property name for associated parameter. No actual parameter object can be passed since JDK offers no representation; just annotations.
      Specified by:
        `findPropertyNameForParam` in class `AnnotationIntrospector`

    - #### findSerializablePropertyName

          public String findSerializablePropertyName(AnnotatedField af)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given member field represent a serializable logical property; and if so, returns the name of that property. Should return null if no annotation is found (indicating it is not a serializable field); otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use the field name as is".
      Specified by:
        `findSerializablePropertyName` in class `AnnotationIntrospector`

    - #### findSettablePropertyName

          public String findSettablePropertyName(AnnotatedMethod am)

      Description copied from class: `AnnotationIntrospector`
      Method for checking whether given method has an annotation that suggests property name associated with method that may be a "setter". Should return null if no annotation is found; otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use standard bean name detection if applicable; method name if not".
      Specified by:
        `findSettablePropertyName` in class `AnnotationIntrospector`